using System;
using System.ServiceProcess;
using System.Management;

[assembly: CLSCompliant(true)]

namespace ServiceControllerEx
{
	public class ServiceControllerEx:ServiceController
	{
		public ServiceControllerEx():base()
		{		}
		public ServiceControllerEx(string name):base(name)
		{		}
		public ServiceControllerEx(string name,string machineName):base(name,machineName)
		{		}

		public string Description
		{
			get
			{
				string path="Win32_Service.Name='"+this.ServiceName+"'";
				ManagementPath p=new ManagementPath(path);
				ManagementObject ManagementObj=new ManagementObject(p);
				if(ManagementObj["Description"]!=null)
				{
					return ManagementObj["Description"].ToString();
				}
				else
				{
					return null;
				}
			}
		}
		
	
		public string  StartupType
		{
			get
			{
				if(this.ServiceName != null)
				{
					string path="Win32_Service.Name='"+this.ServiceName+"'";
					ManagementPath p=new ManagementPath(path);
					ManagementObject ManagementObj=new ManagementObject(p);
					return ManagementObj["StartMode"].ToString();
				}
				else
				{
					return null;
				}
			}
			set
			{
				if(value!="Automatic" && value!="Manual" && value!="Disabled")
					throw new Exception("The valid values are Automatic, Manual or Disabled");

				if(this.ServiceName!=null)
				{
					string path="Win32_Service.Name='"+this.ServiceName+"'";
					ManagementPath p=new ManagementPath(path);
					ManagementObject ManagementObj=new ManagementObject(p);
					object[] parameters=new object[1];
					parameters[0]=value;
					ManagementObj.InvokeMethod("ChangeStartMode",parameters);				
				}
			}
		}
		
}
	
}
